//---------------------------------------------------------------------------
//
// Name:        wxCImgFrm.cpp
// Author:      Jacek
// Created:     2008-06-29 23:28:15
// Description: wxCImgFrm class implementation
//
//---------------------------------------------------------------------------


#include "wxCImgFrm.h"
#include "CImg.h"

using namespace cimg_library;

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// wxCImgFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(wxCImgFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(wxCImgFrm::OnClose)
	EVT_BUTTON(ID_WXBUTTON1,wxCImgFrm::WxButton1Click)
	
	EVT_UPDATE_UI(ID_WXSCROLLEDWINDOW1,wxCImgFrm::WxScrolledWindow1UpdateUI)
END_EVENT_TABLE()
////Event Table End

wxCImgFrm::wxCImgFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
	this->SetBackgroundColour(RGB(192,192,192));
	wxImage::AddHandler( new wxJPEGHandler );       // Dodajemy handlery do formatow
	wxImage::AddHandler( new wxPNGHandler );        // z jakich bedziemy korzytsac
	wxImage image("test.jpg");                      // Tworzymy image wczytujac od razu obrazk z pliku
    if (!image.Ok()) wxMessageBox("Nie udao si zaadowac obrazka");
    Img_Org=image.Copy();                           // Kopiujemy obrazek do Img_Org
    WxScrolledWindow1->SetScrollbars(25,25,52,40);  // Ustalamy zakres zmiennosci suwakow okna z suwakami
   	WxScrolledWindow1->SetBackgroundColour(RGB(192,192,192));	
}

wxCImgFrm::~wxCImgFrm()
{
}

void wxCImgFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxBoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(true);

	WxScrolledWindow1 = new wxScrolledWindow(this, ID_WXSCROLLEDWINDOW1, wxPoint(5,5), wxSize(467,478), wxVSCROLL | wxHSCROLL);
	WxScrolledWindow1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer1->Add(WxScrolledWindow1,1,wxEXPAND | wxALL,5);

	WxBoxSizer2 = new wxBoxSizer(wxVERTICAL);
	WxBoxSizer1->Add(WxBoxSizer2, 0, wxALIGN_CENTER | wxALL, 5);

	WxButton1 = new wxButton(this, ID_WXBUTTON1, wxT("Erode"), wxPoint(6,5), wxSize(75,25), 0, wxDefaultValidator, wxT("WxButton1"));
	WxButton1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxButton1,0,wxALIGN_CENTER | wxALL,5);

	SetTitle(wxT("wxCImg"));
	SetIcon(wxNullIcon);
	
	GetSizer()->Layout();
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	Center();
	
	////GUI Items Creation End
}

void wxCImgFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}

/*
 * WxScrolledWindow1UpdateUI
 */
void wxCImgFrm::WxScrolledWindow1UpdateUI(wxUpdateUIEvent& event)
{
    wxBitmap bitmap(Img_Org);           // Tworzymy tymczasowa bitmape na podstawie Img_Cpy
    wxClientDC dc(WxScrolledWindow1);   // Pobieramy kontekst okna
    WxScrolledWindow1->DoPrepareDC(dc); // Musimy wywolac w przypadku wxScrolledWindow, zeby suwaki prawidlowo dzialaly
    dc.DrawBitmap(bitmap, 0, 0, true);  // Rysujemy bitmape na kontekscie urzadzenia
}

/*
 * WxButton1Click
 */
void wxCImgFrm::WxButton1Click(wxCommandEvent& event)
{
	wxBusyCursor wait;

    CImg<unsigned char> img(Img_Org.GetWidth(),Img_Org.GetHeight(),1,3);
	CImg<float> msk(Img_Org.GetWidth(),Img_Org.GetHeight(),1,3);
	cimg_forXY(img,x,y)
	{
      img(x,y,0) = Img_Org.GetRed(x,y);  
      img(x,y,1) = Img_Org.GetGreen(x,y);  
      img(x,y,2) = Img_Org.GetBlue(x,y);  
    }
    img.erode(10);
    cimg_forXY(img,x,y) Img_Org.SetRGB(x,y,img(x,y,0),img(x,y,1),img(x,y,2));
}

/*
 * WxButton2Click
 */
void wxCImgFrm::WxButton2Click(wxCommandEvent& event)
{
	// insert your code here
}
